// Individual.cpp: implementation of the CIndividual class.
//
//////////////////////////////////////////////////////////////////////

#include "Individual.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

int CIndividual::index_of_normal  = 100;
int CIndividual::index_of_cec2013 = 100;
long int CIndividual::Max_of_NFEs = 150000;

CIndividual::CIndividual()
{
	xreal = new double[N_of_x];
	constr = new double[N_of_constr];
	for (int i=0;i<N_of_x;i++)
	{
		xreal[i] = -1.0;
	}
	for (i=0;i<N_of_constr;i++)
	{
		constr[i] = -1.0;
	}
	constr_violation = -1.0;
	obj              = -1.0;
	fitness          = -1.0;
	feasible         = 0;
	no_of_violation  = 0;

	F  = 0.5;
	CR = 0.9;

	accepted = 0;
	
	eta = new double[N_of_x];
	for (i=0;i<N_of_x;i++)
	{
		eta[i] = 3.0;
	}

	Velocity = new double[N_of_x];
	for (i=0;i<N_of_x;i++)
	{
		Velocity[i]   = 0.0;
	}
}

CIndividual::~CIndividual()
{
	delete []xreal;
	if((N_of_constr != 0)) delete[] constr;
	
	delete []eta;
	delete []Velocity;
}

CIndividual::CIndividual(const CIndividual &t)
{
	// жǷͬ
	if(&t == this)
	{
		return;
	}
	
	// ֵthis
	xreal = new double[N_of_x];
	constr = new double[N_of_constr];
	for (int i=0;i<N_of_x;i++)
	{
		xreal[i] = t.xreal[i];
	}
	obj = t.obj;
	fitness = t.fitness;
	for (i=0;i<N_of_constr;i++)
	{
		constr[i] = t.constr[i];
	}
	constr_violation = t.constr_violation;
	feasible         = t.feasible;
	no_of_violation  = t.no_of_violation;

	F  = t.F;
	CR = t.CR;

	accepted = t.accepted;

	eta = new double[N_of_x];
	for (i=0;i<N_of_x;i++)
	{
		eta[i] = t.eta[i];
	}

	Velocity = new double[N_of_x];
	for (i=0;i<N_of_x;i++)
	{
		Velocity[i]   = t.Velocity[i];
	}
}

CIndividual &CIndividual::operator =(const CIndividual &t)
{
	// жǷͬ
	if(&t == this)
	{
		return *this;
	}

    // !!!!жǷѾռ,Ҫ,Ȼڴ治ͷ!!!!
	if ((N_of_x != 0) && (xreal)) delete[] xreal;
	if((N_of_constr != 0) && (constr)) delete[] constr;

	xreal = new double[N_of_x];
	constr = new double[N_of_constr];
	for (int i=0;i<N_of_x;i++)
	{
		xreal[i] = t.xreal[i];
	}
	obj = t.obj;
	fitness = t.fitness;
	for (i=0;i<N_of_constr;i++)
	{
		constr[i] = t.constr[i];
	}
	constr_violation = t.constr_violation;
	feasible         = t.feasible;
	no_of_violation  = t.no_of_violation;

	F  = t.F;
	CR = t.CR;

	accepted = t.accepted;

	if((N_of_x != 0) && (eta)) delete[] eta;
	eta = new double[N_of_x];
	for (i=0;i<N_of_x;i++)
	{
		eta[i] = t.eta[i];
	}

	if((N_of_x != 0) && (Velocity)) delete[] Velocity;
	Velocity = new double[N_of_x];
	for (i=0;i<N_of_x;i++)
	{
		Velocity[i]   = t.Velocity[i];
	}

	return *this;
}
